#include "StdAfx.h"
#include ".\demiseitemlist.h"

#include "AtlFile.h"

CDemiseItemList::CDemiseItemList(void)
{
}

CDemiseItemList::~CDemiseItemList(void)
{
}

HRESULT CDemiseItemList::LoadFile(const CString & strFileName)
{
	HRESULT hr=E_FAIL;
	CAtlFile objItemFile;

	hr = objItemFile.Create(strFileName,GENERIC_READ,FILE_SHARE_READ,OPEN_EXISTING);
	if (SUCCEEDED(hr))
	{
		hr= objItemFile.Seek(0,FILE_BEGIN);

		if (SUCCEEDED(hr))
		{
			hr=objItemFile.GetSize(m_ulSize);
			if (SUCCEEDED(hr))
			{

				m_pData.Free();
				if (!m_pData.Allocate(m_ulSize))
				{
					return E_OUTOFMEMORY;
				}

				ATLASSERT(m_pData);


				hr= objItemFile.Read(m_pData,m_ulSize);
				if (SUCCEEDED(hr))
				{
					m_arrItemsIndex.clear();
					m_arrItemsNameIndex.clear();
					DemiseItemsHeader * pDemiseItemsHeader = (DemiseItemsHeader *) m_pData.m_p;

					m_arrItemsIndex.resize(pDemiseItemsHeader->iItems);
					m_arrItemsNameIndex.resize(pDemiseItemsHeader->iItems);

					m_arrItemsNameIndex[0] = sizeof(DemiseItemsHeader);

					DemiseItemName * pDemiseItemName = (DemiseItemName *)(m_pData.m_p + m_arrItemsNameIndex[0]);

					m_arrItemsIndex[0] = m_arrItemsNameIndex[0] + sizeof(DemiseItemName)+ pDemiseItemName->iNameL;


					for(short i=1;i<pDemiseItemsHeader->iItems;i++)
					{
						m_arrItemsNameIndex[i] =  m_arrItemsIndex[i-1]+ sizeof(DemiseItem);
						pDemiseItemName = (DemiseItemName *)(m_pData.m_p + m_arrItemsNameIndex[i]);

					    m_arrItemsIndex[i] = m_arrItemsNameIndex[i] + sizeof(DemiseItemName)+ pDemiseItemName->iNameL;
					}
				}
			}
		}
	}

	return hr;
}

HRESULT CDemiseItemList::SaveFile(const CString & strFileName)
{
	HRESULT hr=E_FAIL;
	CAtlFile objItemFile;

	hr = objItemFile.Create(strFileName,GENERIC_WRITE,0,OPEN_ALWAYS);
	if (SUCCEEDED(hr))
	{
		hr= objItemFile.Seek(0,FILE_BEGIN);

		if (SUCCEEDED(hr))
		{
			hr=objItemFile.SetSize(0);
			if (SUCCEEDED(hr))
			{
				ATLASSERT(m_pData);
				hr= objItemFile.Write(m_pData,m_ulSize);
			}
		}
	}

	return hr;
}
